#define kbSpace      0x0034
#define kbCtrlA      0x0101
#define kbCtrlB      0x0102
#define kbCtrlC      0x0103
#define kbCtrlD      0x0104
#define kbCtrlE      0x0105
#define kbCtrlF      0x0106
#define kbCtrlG      0x0107
#define kbCtrlH      0x0108
#define kbCtrlI      0x0109
#define kbCtrlJ      0x010a
#define kbCtrlK      0x010b
#define kbCtrlL      0x010c
#define kbCtrlM      0x010d
#define kbCtrlN      0x010e
#define kbCtrlO      0x010f
#define kbCtrlP      0x0110
#define kbCtrlQ      0x0111
#define kbCtrlR      0x0112
#define kbCtrlS      0x0113
#define kbCtrlT      0x0114
#define kbCtrlU      0x0115
#define kbCtrlV      0x0116
#define kbCtrlW      0x0117
#define kbCtrlX      0x0118
#define kbCtrlY      0x0119
#define kbCtrlZ      0x011a
#define kbEsc        0x001f
#define kbAltSpace   0x0234
#define kbCtrlIns    0x014d
#define kbShiftIns   0x00cd
#define kbCtrlDel    0x014e
#define kbShiftDel   0x00ce
#define kbCtrlShiftIns  0x01cd
#define kbCtrlShiftDel  0x01ce
#define kbBack       0x012a
#define kbCtrlBack   0x002a
#define kbShiftTab   0x00ab
#define kbTab        0x002b
#define kbAltA       0x0201
#define kbAltB       0x0202
#define kbAltC       0x0203
#define kbAltD       0x0204
#define kbAltE       0x0205
#define kbAltF       0x0206
#define kbAltG       0x0207
#define kbAltH       0x0208
#define kbAltI       0x0209
#define kbAltJ       0x020a
#define kbAltK       0x020b
#define kbAltL       0x020c
#define kbAltM       0x020d
#define kbAltN       0x020e
#define kbAltO       0x020f
#define kbAltP       0x0210
#define kbAltQ       0x0211
#define kbAltR       0x0212
#define kbAltS       0x0213
#define kbAltT       0x0214
#define kbAltU       0x0215
#define kbAltV       0x0216
#define kbAltW       0x0217
#define kbAltX       0x0218
#define kbAltY       0x0219
#define kbAltZ       0x021a
#define kbCtrlEnter  0x012c
#define kbEnter      0x002c
#define kbF1         0x0039
#define kbF2         0x003a
#define kbF3         0x003b
#define kbF4         0x003c
#define kbF5         0x003d
#define kbF6         0x003e
#define kbF7         0x003f
#define kbF8         0x0040
#define kbF9         0x0041
#define kbF10        0x0042
#define kbF11        0x0043
#define kbF12        0x0044
#define kbHome       0x0045
#define kbUp         0x0046
#define kbPgUp       0x0047
#define kbLeft       0x0048
#define kbRight      0x0049
#define kbEnd        0x004a
#define kbDown       0x004b
#define kbPgDn       0x004c
#define kbIns        0x004d
#define kbDel        0x004e
#define kbGrayMinus  0x0035
#define kbGrayPlus   0x0036
#define kbShiftF1    0x00b9
#define kbShiftF2    0x00ba
#define kbShiftF3    0x00bb
#define kbShiftF4    0x00bc
#define kbShiftF5    0x00bd
#define kbShiftF6    0x00be
#define kbShiftF7    0x00bf
#define kbShiftF8    0x00c0
#define kbShiftF9    0x00c1
#define kbShiftF10   0x00c2
#define kbShiftF11   0x00c3
#define kbShiftF12   0x00c4
#define kbCtrlF1     0x0139
#define kbCtrlF2     0x013a
#define kbCtrlF3     0x013b
#define kbCtrlF4     0x013c
#define kbCtrlF5     0x013d
#define kbCtrlF6     0x013e
#define kbCtrlF7     0x013f
#define kbCtrlF8     0x0140
#define kbCtrlF9     0x0141
#define kbCtrlF10    0x0142
#define kbCtrlF11    0x0143
#define kbCtrlF12    0x0144
#define kbAltF1      0x0239
#define kbAltF2      0x023a
#define kbAltF3      0x023b
#define kbAltF4      0x023c
#define kbAltF5      0x023d
#define kbAltF6      0x023e
#define kbAltF7      0x023f
#define kbAltF8      0x0240
#define kbAltF9      0x0241
#define kbAltF10     0x0242
#define kbAltF11     0x0243
#define kbAltF12     0x0244
#define kbCtrlPrtSc  0x0137
#define kbCtrlLeft   0x0148
#define kbCtrlRight  0x0149
#define kbCtrlEnd    0x014a
#define kbCtrlPgDn   0x014c
#define kbCtrlHome   0x0145
#define kbAlt1       0x0221
#define kbAlt2       0x0222
#define kbAlt3       0x0223
#define kbAlt4       0x0224
#define kbAlt5       0x0225
#define kbAlt6       0x0226
#define kbAlt7       0x0227
#define kbAlt8       0x0228
#define kbAlt9       0x0229
#define kbAlt0       0x0220
#define kbAltMinus   0x0235
#define kbAltEqual   0x0238
#define kbCtrlPgUp   0x0147
#define kbAltBack    0x022a
#define kbNoKey      0x0000

// Editor windows' commands
#define cmcNoCommand 600
#define cmcToLower 601
#define cmcSelLength 602
#define cmcFirstLineInScreen 603
#define cmcLastLineInScreen 604
#define cmcIndentBlkOne 605
#define cmcUnIndentBlkOne 606
#define cmcIndentBlk 607
#define cmcUnIndentBlk 608
#define cmcSearchStart 609
#define cmcSearchEnd 610
#define cmcExpandCode 611
#define cmcDelPrevWord 612
#define cmcEndSelect 613
#define cmcSmartUnIndent 614
#define cmcSmartIndent 615
#define cmcReplaceSelect 616
#define cmcGotoEditorLine 617
#define cmcGoBeginBlock 618
#define cmcGoEndBlock 619
#define cmcMarkLine 620
#define cmcMarkWord 621
#define cmcMoveBlock 622
#define cmcScrollDown 623
#define cmcScrollUp 624
#define cmcPutMark0 625
#define cmcPutMark1 626
#define cmcPutMark2 627
#define cmcPutMark3 628
#define cmcPutMark4 629
#define cmcPutMark5 630
#define cmcPutMark6 631
#define cmcPutMark7 632
#define cmcPutMark8 633
#define cmcPutMark9 634
#define cmcGotoMark0 635
#define cmcGotoMark1 636
#define cmcGotoMark2 637
#define cmcGotoMark3 638
#define cmcGotoMark4 639
#define cmcGotoMark5 640
#define cmcGotoMark6 641
#define cmcGotoMark7 642
#define cmcGotoMark8 643
#define cmcGotoMark9 644
#define cmcInsertText 645
#define cmcReadBlock 646
#define cmcWriteBlock 647
#define cmcNewLine 648
#define cmcBackSpace 649
#define cmcCharLeft 650
#define cmcCharRight 651
#define cmcWordLeft 652
#define cmcWordRight 653
#define cmcLineStart 654
#define cmcLineEnd 655
#define cmcLineUp 656
#define cmcLineDown 657
#define cmcPageUp 658
#define cmcPageDown 659
#define cmcTextStart 660
#define cmcTextEnd 661
#define cmcDelChar 662
#define cmcDelWord 663
#define cmcDelStart 664
#define cmcDelEnd 665
#define cmcDelLine 666
#define cmcInsMode 667
#define cmcStartSelect 668
#define cmcHideSelect 669
#define cmcIndentMode 670
#define cmcUpdateTitle 671
#define cmcCut 672
#define cmcCopy 673
#define cmcPaste 674
#define cmcUndo 675
#define cmcSearchAgain 676
#define cmcClear 677
#define cmcReplace 678
#define cmcFind 679
#define cmcSearchOpPar 680
#define cmcSearchClPar 681
#define cmcSearchOpCor 682
#define cmcSearchClCor 683
#define cmcToUpper 684
#define cmcRedo 685
#define cmcSetLocalOptions 686
#define cmcExpandAllTabs 687
#define cmcCompactBuffer 688
#define cmcRecordMacro 689
#define cmcStopMacro 690
#define cmcPlayMacro 691
#define cmcSetGlobalOptions 692
#define cmcSaveAsUNIX 693
#define cmcCopyBlock 694
#define cmcSelRectStart 695
#define cmcSelRectEnd 696
#define cmcSelRectCopy 697
#define cmcSelRectPaste 698
#define cmcSelRectDel 699
#define cmcSelRectCut 700
#define cmcSelRectMove 701
#define cmcSelRectHide 702
#define cmcLastPosCur 703
#define cmcToggleMoveOnPaste 704
#define cmcJumpToFunction 705
#define cmcProfileEditor 706
#define cmcColorsChanged 707
#define cmcLoadFileUnderCur 708
#define cmcSearchComplement 709
#define cmcCopyClipWin 710
#define cmcPasteClipWin 711
#define cmcIntelIndentMode 712
#define cmcDelCharClear 713
#define cmcSave 714
#define cmcSaveAs 715
#define cmcChooseMacro 716
#define cmcRepeatMacro 717
#define cmcGenCodeForMacro 718
#define cmcSelectOn 719
#define cmcSelectOff 720
#define cmcSaveSameTime 721
#define cmcWrapOn 722
#define cmcWrapOff 723
#define cmcWrapToggle 724

// SET's editor commands
#define cmeOpen           0x2500
#define cmeNew            0x2501
#define cmeChangeDrct     0x2502
#define cmeDosShell       0x2503
#define cmeCalculator     0x2504
#define cmeShowClip       0x2505
#define cmeInfView        0x2506
#define cmeListWin        0x2507
#define cmeLastHelp       0x2508
#define cmeUserScreen     0x2509
#define cmeAnotherInfView 0x250A
#define cmeOpenPrj        0x250B
#define cmeClosePrj       0x250C
#define cmeSDG            0x250D
#define cmeSDGDialog      0x250E
#define cmeSetColors      0x250F
#define cmeQuitDelete     0x2510
#define cmeQuit           0x2511
#define cmeResize         0x2512
#define cmeZoom           0x2513
#define cmeTile           0x2514
#define cmeCascade        0x2515
#define cmeNext           0x2516
#define cmePrev           0x2517
#define cmeClose          0x2518
#define cmeEditKeyBind    0x2519
#define cmeLoadKeyScans   0x251A
#define cmeSetUpAltKeys   0x251B
#define cmeKbBackDefault  0x251C
#define cmeSeeScanCodes   0x251D
#define cmePrintEditor    0x251E
#define cmeSetUpPrinter   0x251F
#define cmeGrepDialog     0x2520
#define cmeNextMessage    0x2521
#define cmePrevMessage    0x2522
#define cmeSetScreenOps   0x2523
#define cmeEditPalette    0x2524
#define cmeEdGralOptions  0x2525
#define cmeRunCommand     0x2526
#define cmeConfRunCommand 0x2527

#define hcNoContext 0

#define smExtend   1
#define smDouble   2
#define smEndSel   4
#define smStartSel 8

